declare module "windows.storage.pickers" {
  export enum PickerViewMode {
    list,
    thumbnail,
  }

  export enum PickerLocationId {
    documentsLibrary,
    computerFolder,
    desktop,
    downloads,
    homeGroup,
    musicLibrary,
    picturesLibrary,
    videosLibrary,
  }

  export class FilePickerSelectedFilesArray {
    constructor();

    getAt(index: Number): Object;

    indexOf(value: Object, index: Number): Boolean;

    getMany();
    first(): Object;

  }

  export class FilePickerFileTypesOrderedMap {
    constructor();

    lookup(key: String): Object;

    hasKey(key: String): Boolean;

    getView(): Object;

    insert(key: String, value: Object): Boolean;

    remove(key: String): void;

    clear(): void;

    first(): Object;

  }

  export class FileExtensionVector {
    constructor();

    getAt(index: Number): String;

    getView(): Object;

    indexOf(value: String, index: Number): Boolean;

    setAt(index: Number, value: String): void;

    insertAt(index: Number, value: String): void;

    removeAt(index: Number): void;

    append(value: String): void;

    removeAtEnd(): void;

    clear(): void;

    getMany();
    replaceAll(items: Array<String>): void;

    first(): Object;

  }

  export class FileOpenPicker {
    viewMode: PickerViewMode;
    suggestedStartLocation: PickerLocationId;
    settingsIdentifier: String;
    commitButtonText: String;
    fileTypeFilter: Object;
    constructor();

    pickSingleFileAsync(callback: (error: Error, result: Object) => void): void ;

    pickMultipleFilesAsync(callback: (error: Error, result: Object) => void): void ;

  }

  export class FileSavePicker {
    suggestedStartLocation: PickerLocationId;
    suggestedSaveFile: Object;
    suggestedFileName: String;
    settingsIdentifier: String;
    defaultFileExtension: String;
    commitButtonText: String;
    fileTypeChoices: Object;
    constructor();

    pickSaveFileAsync(callback: (error: Error, result: Object) => void): void ;

  }

  export class FolderPicker {
    viewMode: PickerViewMode;
    suggestedStartLocation: PickerLocationId;
    settingsIdentifier: String;
    commitButtonText: String;
    fileTypeFilter: Object;
    constructor();

    pickSingleFolderAsync(callback: (error: Error, result: Object) => void): void ;

  }

}



